/*
 * message2.c
 *
 * This program sends a message to message1 process.
 * You should first run message1, and then message2 on a machine in the
 * same cluster
 *
 * By Kamran Karimi
 */

#include "message.h"

int main()
{
 int msgid;
 struct message mess;
 
 /* gain access to the message queue that was created by message1 */
 msgid = msgget(MSG_KEY, MSG_MODE);
 if(msgid < 0) 
 {
  fprintf(stderr,"Message2: msgget() failed BECAUSE %s\n",strerror(errno));
  exit(20);
 }
 mess.mtype = MSG_TYPE; /* not necessary here */
 strcpy(mess.mtext,"HI!, Greetings From That Remote(?) Machine!");
 /* now send the message. This will traverse the network if message1 and
    message2 programs are in different computers and DIPC is properly
    installed */
 if(msgsnd(msgid, (struct msgbuf *)&mess, sizeof(mess.mtext), 0) < 0)
 {
  fprintf(stderr,"Message2: msgsnd() failed: %s\n", strerror(errno));
  exit(20);
 }
 exit(0);
}
